unit Unit1;

interface

uses
  tiltCards,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure onCartaJogClick(sender: TObject);
    procedure vezDoComputador;
    procedure jogarCarta(var carta: TCard);
  end;

var
  Form1: TForm1;
  baralho: TDeck;
  jc1, jc2, jc3: TCard; //cartas do jogador
  cc1, cc2, cc3: TCard; //cartas do computador

  cartaSelecionada: TCard; //carta q o jogador selecionou para jogar
  pontosJog, pontosComp: integer; //pontos do jogador e do computador (na rodada)
  rodada: integer; //numero da rodada (1, 2 ou 3)

implementation

{$R *.DFM}

procedure TForm1.jogarCarta(var carta: TCard);
begin
     with carta do begin
          if value > cartaSelecionada.Value then
               pontosComp:= pontosComp + 1
          else if value < cartaSelecionada.Value then
               pontosJog:= pontosJog + 1
          else begin
               pontosJog:= pontosJog + 1;
               pontosComp:= pontosComp + 1;
          end;
          left:= 200 + rodada * 150;
          Top:= 120;
          ShowDeck:= false;
          BringToFront;
     end;
     carta:= nil;
end;

procedure TForm1.vezDoComputador;
var
jogou: boolean;
begin
     //escolher uma que vena o jogador
     if assigned(cc1) and (cc1.Value > cartaSelecionada.Value) then
          jogarCarta(cc1)
     else if assigned(cc2) and (cc2.Value > cartaSelecionada.value) then
          jogarCarta(cc2)
     else if assigned(cc3) and (cc3.value > cartaSelecionada.value) then
          jogarCarta(cc3)
     else begin
          //nenhuma carta vence o jogador.
          //jogar uma carta randmica
          repeat
               jogou:= true;
               case random(3) of
                    0: if assigned(cc1) then jogarCarta(cc1) else jogou:= false;
                    1: if assigned(cc2) then jogarCarta(cc2) else jogou:= false;
                    2: if assigned(cc3) then jogarCarta(cc3) else jogou:= false;
               end;
          until jogou = true;
     end;

     //verificar resultado
     if pontosJog - pontosComp >= 2 then
          label1.caption:= 'Voc venceu!'
     else if pontosComp - pontosJog >= 2 then
          label1.caption:= 'O computador venceu!'
     else if rodada = 2 then begin
          if pontosJog > pontosComp then
               label1.caption:= 'Voc venceu!'
          else if pontosComp > pontosJog then
               label1.caption:= 'O computador venceu!'
          else
               label1.caption:= 'Empate!';
     end;

     inc(rodada);
end;

procedure TForm1.onCartaJogClick(sender: TObject);
begin
     with TCard(sender) do begin
          left:= 135 + rodada * 150;
          Top:= 130;
     end;
     cartaSelecionada:= TCard(sender);
     cartaSelecionada.OnClick:= nil;
     vezDoComputador;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     baralho:= TDeck.create(self, point(0, 0));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     baralho.free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
i: integer;
begin
     //embaralhar
     baralho.shuffle;
     for i:= 0 to 51 do
          with baralho.deckObj[i] do Begin
               visible:=true;
               left:= 10;
               top:= 10;
               showdeck:= true;
          end;


     //pegar cartas do jogador
     baralho.GetNextCard(jc1);
     baralho.GetNextCard(jc2);
     baralho.GetNextCard(jc3);
     jc1.Left:= 170; jc1.top:= 256; jc1.ShowDeck:= false; jc1.OnClick:= onCartaJogClick;
     jc2.Left:= 150; jc2.top:= 256; jc2.ShowDeck:= false; jc2.OnClick:= onCartaJogClick;
     jc3.Left:= 130; jc3.top:= 256; jc3.ShowDeck:= false; jc3.OnClick:= onCartaJogClick;

     //pegar cartas do computador
     baralho.GetNextCard(cc1);
     baralho.GetNextCard(cc2);
     baralho.GetNextCard(cc3);
     cc1.Left:= 170; cc1.top:= 10;
     cc2.Left:= 150; cc2.top:= 10;
     cc3.Left:= 120; cc3.top:= 10;

     //zerar contadores
     pontosJog:= 0; pontosComp:= 0; rodada:= 0;
end;

end.
